#pragma once

#include "state.h"
#include "core/music.h"
#include "core/game.h"

class Group;

class GameState : public GUIState
{
public:

    struct Callbacks
    {
        std::function<void(void)> onLeaveGame;
    };


    explicit GameState(const std::shared_ptr<kku::Game>& game, Callbacks&& callbacks);

    virtual void input(const kku::SystemEvent& event) override;
    virtual void update(const kku::microsec& dt) override;
    virtual void display() const override;

    virtual void enter() override;
    virtual void leave() override;

private:
    std::shared_ptr<kku::Music> _music;
    std::shared_ptr<kku::Game> _game;

    std::function<void(void)> _onEnterGameCallback;
    std::function<void(void)> _onLeaveGameCallback;
};

